//+------------------------------------------------------------------+
//|                                     Custom Relative Strength.mq4 |
//|                                                         Dan King |
//|                                              todasouth@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Dan King"
#property link      "todasouth@yahoo.com"

#property indicator_chart_window

   string CurrencyString[]={"USD","EUR","GBP","AUD","JPY","CAD","CHF"};
   string PairString[19,3]={"EURUSD","01","10",
                            "GBPUSD","02","20",
                            "AUDUSD","03","30",
                            "USDJPY","40","04",
                            "USDCHF","60","06",
                            "USDCAD","50","05",
                            "EURGBP","21","12",
                            "EURAUD","31","13",
                            "EURJPY","41","14",
                            "EURCHF","61","16",
                            "EURCAD","51","15",
                            "GBPJPY","42","24",
                            "GBPCHF","62","26",
                            "GBPCAD","52","25",
                            "AUDJPY","43","34",
                            "AUDCHF","63","36",
                            "AUDCAD","53","35",
                            "CHFJPY","46","64",
                            "CADJPY","45","54"};
   
   int MATrendPeriod[]={5,8,21,55};

   int MATimeFrame = 30;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   for (int i=0;i<7;i++)
       {
          ObjectCreate("vLabel_Currency"+i, OBJ_LABEL, 0, 0, 0);// Creating obj.
          ObjectSet("vLabel_Currency"+i, OBJPROP_CORNER, 0);    // Reference corner
          ObjectSet("vLabel_Currency"+i, OBJPROP_XDISTANCE, 10);// X coordinate
          ObjectSet("vLabel_Currency"+i, OBJPROP_YDISTANCE, 37+i*20);// Y coordinate
          ObjectSetText("vLabel_Currency"+i,CurrencyString[i],8,"Tahoma",Black);
       }

   for (int j=0;j<7;j++)
       {
          ObjectCreate("hLabel_Currency"+j, OBJ_LABEL, 0, 0, 0);// Creating obj.
          ObjectSet("hLabel_Currency"+j, OBJPROP_CORNER, 0);    // Reference corner
          ObjectSet("hLabel_Currency"+j, OBJPROP_XDISTANCE, 40+j*30);// X coordinate
          ObjectSet("hLabel_Currency"+j, OBJPROP_YDISTANCE, 20);// Y coordinate
          ObjectSetText("hLabel_Currency"+j,CurrencyString[j],8,"Tahoma",Black);
       }
        
   for(int x=0;x<7;x++)
      for(int y=0;y<7;y++)
      {
         if ((x!=y) && (x!=2 || y!=3) && (x!=3 || y!=2) && (x!=5 || y!=6) && (x!=6 || y!=5))
         {
         ObjectCreate("signal"+x+y,OBJ_LABEL,0,0,0,0,0);
         ObjectCreate("signal_text"+x+y,OBJ_LABEL,0,0,0,0,0);
         // create the next mark, Note that the mark name
         // is created "on the fly" and depends on "x" and "y" counters
 
         ObjectSet("signal"+x+y,OBJPROP_XDISTANCE,x*30+40);
         ObjectSet("signal_text"+x+y,OBJPROP_XDISTANCE,x*30+45);
         // change the X coordinate.
         // x*30 - each mark is created at the interval of 30 pixels
         // horizontally and directly depends on the "x" counter
 
         ObjectSet("signal"+x+y,OBJPROP_YDISTANCE,y*20+30);
         ObjectSet("signal_text"+x+y,OBJPROP_YDISTANCE,y*20+35);
         // change the Y coordinate.
         // y*20 - each mark is created at the interval of 20 pixels
         // vertically and directly depends on the "y" counter
 
         ObjectSetText("signal"+x+y,CharToStr(110),20,"Wingdings",Gold);
         ObjectSetText("signal_text"+x+y,"",20,"Wingdings",Gold);
         // use the 110th symbol code (square)
         }
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int ctr;
   double total;
   int Strength[4];

   for(int x=0;x<19;x++)
   {
      Strength[4]={0,0,0,0};
      ctr=0;
      total=0;
      for(int y=0;y<4;y++)
      {
         if(iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,0)>iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,1) &&
            iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,1)>iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,2) && 
            iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,2)>iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,3) &&
            iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,3)>iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,4))
            {
               Strength[y] = 1;
               ctr++;
            }
         if(iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,0)<iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,1) &&
            iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,1)<iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,2) && 
            iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,2)<iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,3) &&
            iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,3)<iMA(PairString[x,0],MATimeFrame,MATrendPeriod[y],0,MODE_EMA,PRICE_CLOSE,4))
            {
               Strength[y] = -1;
               ctr++;
            }
         total = total + Strength[y];
      }
      if (total>0)
         {
            if (MarketInfo(PairString[x,0],MODE_BID) > iMA(PairString[x,0],MATimeFrame,200,0,MODE_SMA,PRICE_CLOSE,0))
               {
                  ObjectSetText("signal"+PairString[x,1],CharToStr(110),20,"Wingdings",DarkGreen);
                  ObjectSetText("signal"+PairString[x,2],CharToStr(110),20,"Wingdings",Red);
               }
            else
               {
                  ObjectSetText("signal"+PairString[x,1],CharToStr(110),20,"Wingdings",MediumSeaGreen);
                  ObjectSetText("signal"+PairString[x,2],CharToStr(110),20,"Wingdings",HotPink);
               }
            ObjectSetText("signal_text"+PairString[x,1],DoubleToStr(total,0),10,"Tahoma",White);
            ObjectSetText("signal_text"+PairString[x,2],DoubleToStr(total,0),10,"Tahoma",White);
         }
      if (total<0)
         {
            if (MarketInfo(PairString[x,0],MODE_ASK) < iMA(PairString[x,0],MATimeFrame,200,0,MODE_SMA,PRICE_CLOSE,0))
               {
                  ObjectSetText("signal"+PairString[x,1],CharToStr(110),20,"Wingdings",Red);
                  ObjectSetText("signal"+PairString[x,2],CharToStr(110),20,"Wingdings",DarkGreen);
               }
            else
               {
                  ObjectSetText("signal"+PairString[x,1],CharToStr(110),20,"Wingdings",HotPink);
                  ObjectSetText("signal"+PairString[x,2],CharToStr(110),20,"Wingdings",MediumSeaGreen);
               }
            ObjectSetText("signal_text"+PairString[x,2],DoubleToStr(MathAbs(total),0),10,"Tahoma",White);
            ObjectSetText("signal_text"+PairString[x,1],DoubleToStr(MathAbs(total),0),10,"Tahoma",White);
         }
      if (total==0)
         {
            ObjectSetText("signal"+PairString[x,1],CharToStr(110),20,"Wingdings",Gold);
            ObjectSetText("signal_text"+PairString[x,1],"",10,"Tahoma",White);               
            ObjectSetText("signal"+PairString[x,2],CharToStr(110),20,"Wingdings",Gold);
            ObjectSetText("signal_text"+PairString[x,2],"",10,"Tahoma",White);               
         }
    }

   return(0);
  }
//+------------------------------------------------------------------+